<?php

declare(strict_types=1);

namespace Drupal\date_point\Data;

use Drupal\Core\StringTranslation\TranslatableMarkup as TM;

/**
 * Represents datetime granularity.
 */
enum Granularity: string {

  case MICROSECOND = 'microsecond';
  case MILLISECOND = 'millisecond';
  case SECOND = 'second';
  case MINUTE = 'minute';
  case HOUR = 'hour';
  case DAY = 'day';
  case MONTH = 'month';
  case YEAR = 'year';

  /**
   * Returns granularity options.
   *
   * @return array<string, \Drupal\Core\StringTranslation\TranslatableMarkup>
   */
  public static function getOptions(): array {
    return [
      self::MICROSECOND->value => new TM('Microsecond'),
      self::MILLISECOND->value => new TM('Millisecond'),
      self::SECOND->value => new TM('Second'),
      self::MINUTE->value => new TM('Minute'),
      self::HOUR->value => new TM('Hour'),
      self::DAY->value => new TM('Day'),
      self::MONTH->value => new TM('Month'),
      self::YEAR->value => new TM('Year'),
    ];
  }

}
